/*******************************************************************************
 * Copyright (c) 2010 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package sample.handlers;

import java.lang.reflect.InvocationTargetException;

import javax.inject.Named;

import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.swt.widgets.Shell;

import sample.product.Item;
import sample.product.Product;

public class OpenHandler {

    @Execute
    public void execute(IEclipseContext context, @Named(IServiceConstants.ACTIVE_SHELL) Shell shell)
            throws InvocationTargetException, InterruptedException {

        System.out.println("OpenHandler - Create product and set it in eclipse context");
        Product p = createProduct();
        context.set(Product.class, p);
    }

    private Product createProduct() {
        Item root = new Item("root");
        Item c1 = new Item("child-1");
        connect(root, c1);
        Item c2 = new Item("child-2");
        connect(root, c2);

        Item c11 = new Item("child-1-1");
        connect(c1, c11);
        Item c12 = new Item("child-1-2");
        connect(c1, c12);
        Item c13 = new Item("child-1-3");
        connect(c1, c13);

        Item c21 = new Item("child-2-1");
        connect(c2, c21);
        Item c22 = new Item("child-2-2");
        connect(c2, c22);

        Item c111 = new Item("child-1-1-1");
        connect(c11, c111);

        Item c121 = new Item("child-1-2-1");
        connect(c12, c121);
        Item c122 = new Item("child-1-2-2");
        connect(c12, c122);

        Item c211 = new Item("child-2-1-1");
        connect(c21, c211);
        Item c212 = new Item("child-2-1-2");
        connect(c21, c212);
        Item c213 = new Item("child-2-1-3");
        connect(c21, c213);
        Item c214 = new Item("child-2-1-4");
        connect(c21, c214);
        Item c215 = new Item("child-2-1-5");
        connect(c21, c215);
        Item c216 = new Item("child-2-1-6");
        connect(c21, c216);

        Item c221 = new Item("child-2-2-1");
        connect(c22, c221);
        Item c222 = new Item("child-2-2-2");
        connect(c22, c222);
        Item c223 = new Item("child-2-2-3");
        connect(c22, c223);
        Item c224 = new Item("child-2-2-4");
        connect(c22, c224);

        Item c1111 = new Item("child-1-1-1-1");
        connect(c111, c1111);
        Item c1112 = new Item("child-1-1-1-2");
        connect(c111, c1112);
        Item c1113 = new Item("child-1-1-1-3");
        connect(c111, c1113);
        Item c1114 = new Item("child-1-1-1-4");
        connect(c111, c1114);
        Item c1115 = new Item("child-1-1-1-5");
        connect(c111, c1115);
        Item c1116 = new Item("child-1-1-1-6");
        connect(c111, c1116);
        Item c1117 = new Item("child-1-1-1-7");
        connect(c111, c1117);
        return new Product(root);
    }

    private void connect(Item parent, Item child) {
        parent.getChildren().add(child);
        child.setParent(parent);
    }
}
